//==============================================
//	FT_ALTERA FTDI FT2232C MPSSE JTAG module	
//		2005/03/01		Ver 0.0					
//												
//	FT2232C(MPSSE) JTAG							
//	    CONFIGRATION & BOUNDARY SCAN PROGRAM	
//			 for Altera FPGA series				
//												
//	Compiled Visual C++ Ver5.0 with D2XX DLL ver.1.10
//												
//	Windows98SE    with D2XX Driver ver.1.10	
//	Windows2000Pro with D2XX Driver ver.1.03	
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================
/*
	{vO̒쌠yт̑؂͍̌{@NL܂B
	āA쌠NQsׂ͖@ɂĈ؋֎~Ă܂B
	{vȎS܂͈ꕔcړIŎgpꍇɂ͕K{@N̎Oʓӂv܂B
	_ɑΉ܂̂łCyɖ₢킹B
	ӌ䊴zCyɂ񂹂B

	{@Ñz[y[W
	http://hp.vector.co.jp/authors/VA014069
*/
//==============================================

#include <stdio.h>
#include <time.h>
#include <windows.h>

#include "FPGA.h"
#include "FT_Jtag.h"
#include "FT_Altera.h"
#include "Altera.h"


//==============================================
#ifdef	_CONSOLE
#define	FT_ALTERA_CONSOLE
#endif


//==============================================
#define	STR_OKNG(f)	((f)? "OK": "NG")

void	Print(char *form, ...);


BYTE	abyTxBscan[JTAG_BUFFER_MAX];
BYTE	abyRxBscan[JTAG_BUFFER_MAX];

//==============================================
//	RUN TEST IDLE
//==============================================
BOOL	RunTestIdle(void)
{
	BOOL	bFlag;

	//	Move RESET
	bFlag	= JT_TxTms(6, 0x3F, 0);
	if (!bFlag)		return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);

	return (bFlag);
}


//==============================================
//	BYPASS
//==============================================
BOOL	Bypass(void)
{
	BOOL	bFlag;
	DWORD	dwRx;

	bFlag	= FALSE;

	//	Move SHIFT_IR
	bFlag	= JT_TxTms(4, 0x03, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(10, JI_BYPASS, &dwRx, 1, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
	if (dwRx != 0x155)	return (FALSE);
	//	Move UPDATE_IR
	bFlag	= JT_TxTms(1, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);
	if (!bFlag)			return (FALSE);

	return (bFlag);
}


//==============================================
//	CHECK CHAIN
//==============================================
BOOL	VerifyChain(void)
{
	BOOL	bFlag;
	DWORD	dwRx;

	//	Move SHIFT_IR
	bFlag	= JT_TxTms(4, 0x03, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(10, JI_BYPASS, &dwRx, 1, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
//	Print("SHIFT_IR %04lX\n", dwRx);
	if (dwRx != 0x155)	return (FALSE);
	//	Move UPDATE_IR
	bFlag	= JT_TxTms(1, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Move SHIFT_DR
	bFlag	= JT_TxTms(3, 0x01, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(8+1, 0x0055, &dwRx, 0, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
	dwRx	>>= 1;
//	Print("SHIFT_DR %04lX\n", dwRx);
	if ((dwRx & 0xFF) != 0x55)		return (FALSE);

	//	Move UPDATE_DR
	bFlag	= JT_TxTms(2, 0x03, 0);
	if (!bFlag)			return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);
	if (!bFlag)			return (FALSE);

	return (bFlag);
}


//==============================================
//	IDCODE
//==============================================
BOOL	GetIdCode(DWORD* pdwIdCode)
{
	BOOL	bFlag;
	DWORD	dwRx;

	if (pdwIdCode)	*pdwIdCode	= 0x00000000;

	//	Move SHIFT_IR
	bFlag	= JT_TxTms(4, 0x03, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(10, JI_IDCODE, &dwRx, 1, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
	if (dwRx != 0x155)	return (FALSE);
	//	Move UPDATE_IR
	bFlag	= JT_TxTms(1, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Move SHIFT_DR
	bFlag	= JT_TxTms(3, 0x01, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(32, 0x0000, &dwRx, 0, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
//	Print("IDCODE 0x%08lX\n", dwRx);
	if (pdwIdCode)	*pdwIdCode	= dwRx;
	//	Move UPDATE_DR
	bFlag	= JT_TxTms(2, 0x03, 0);
	if (!bFlag)			return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);
	if (!bFlag)			return (FALSE);

	return (bFlag);
}


//==============================================
//	Get Device Type
//==============================================
DEVICE_INFO_T* GetDeviceInfo(DWORD dwIdCode)
{
	int	i;

	i	= 0;
	while (atDeviceInfo[i].dwIdCode)
	{
		if (atDeviceInfo[i].dwIdCode == dwIdCode)
		{
			return (&atDeviceInfo[i]);
		}

		i ++;
	}

	return (NULL);
}


//==============================================
//	CONFIGURE ALTERA FPGA
//==============================================
BOOL	Configure(DEVICE_INFO_T* ptDeviceInfo, char* szFileName)
{
	BOOL	bFlag;
	DWORD	dwRx;

	bFlag	= FALSE;

	//==============================================
	//	PROGRAM
	//==============================================
	//	Move SHIFT_IR
	bFlag	= JT_TxTms(4, 0x03, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(10, JI_PROGRAM, &dwRx, 1, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
	if (dwRx != 0x155)	return (FALSE);
	//	Move UPDATE_IR
	bFlag	= JT_TxTms(1, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Drive TDI HIGH while moving JSM to SHIFTDR
	//	Move SHIFT_DR
	bFlag	= JT_TxTms(3, 0x01, 1);
	if (!bFlag)			return (FALSE);

	//	Issue MAX_JTAG_INIT_CLOCK clocks in SHIFTDR state
//	Print("MaxClk %d,%s", ptDeviceInfo->nMaxClk, ptDeviceInfo->szDeviceName);
	bFlag	= JT_PluseTck(ptDeviceInfo->nMaxClk, 1);
	if (!bFlag)			return (FALSE);

	//==============================================
	//	Transfer Bit-File
	bFlag	= ProcessFileInput(ptDeviceInfo, szFileName);
	Print("Transfer Bit-File...");
	Print("%s\n", STR_OKNG(bFlag));
	if (!bFlag)			return (FALSE);

	//	Move UPDATE_DR
	bFlag	= JT_TxTms(2, 0x03, 0);
	if (!bFlag)			return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);
	if (!bFlag)			return (FALSE);


	//	STARTUP
	bFlag	= Startup(ptDeviceInfo);
	if (!bFlag)			return (FALSE);

	//	CHECK STATUS
	bFlag	= CheckStatus(ptDeviceInfo);

	//	BYPASS
	bFlag	= PostBypass(ptDeviceInfo);
	if (!bFlag)			return (FALSE);

	return (bFlag);
}


//==============================================
//	STARTUP
//==============================================
BOOL	Startup(DEVICE_INFO_T* ptDeviceInfo)
{
	BOOL	bFlag;
	DWORD	dwRx;

	bFlag	= FALSE;

	//	Load STARTUP instruction to move the device to USER mode
	//	Move SHIFT_IR
	bFlag	= JT_TxTms(4, 0x03, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(10, JI_STARTUP, &dwRx, 1, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
	if (dwRx != 0x155)	return (FALSE);
	//	Move UPDATE_IR
	bFlag	= JT_TxTms(1, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);
	if (!bFlag)			return (FALSE);

	//	Initialize FPGA Clock for STARTUP
	bFlag	= JT_PluseTck(FPGA_INIT_COUNT, 0);
	if (!bFlag)		return (FALSE);

	//	Reset JSM after the device is in USER mode
	//	Move RESET
	bFlag	= JT_TxTms(6, 0x3F, 0);
	if (!bFlag)		return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);

	return (bFlag);
}


//==============================================
//	CHECK_STATUS
//==============================================
BOOL	CheckStatus(DEVICE_INFO_T* ptDeviceInfo)
{
	BOOL	bFlag;
	DWORD	dwRx;
	int		cnt;

	bFlag	= FALSE;

	//	Move SHIFT_IR
	bFlag	= JT_TxTms(4, 0x03, 0);
	if (!bFlag)			return (FALSE);
	bFlag	= JT_TxRxDword(10, JI_CHECK_STATUS, &dwRx, 1, JTAG_TIMEOUT);
	if (!bFlag)			return (FALSE);
	if (dwRx != 0x155)	return (FALSE);
	//	Move UPDATE_IR
	bFlag	= JT_TxTms(1, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Move SHIFT_DR
	bFlag	= JT_TxTms(3, 0x01, 0);
	if (!bFlag)			return (FALSE);

	//	Drive TDI LOW while clocking JTAG sequence
	//	Maximum JTAG sequence of the device
	cnt	= ((ptDeviceInfo->nMaxClk-ptDeviceInfo->nDoneClk) * 3) + 1;
//	Print("ConfClk %d", cnt);
	bFlag	= JT_PluseTck(cnt, 0);
	if (!bFlag)			return (FALSE);

	//	Check Done Status
	bFlag	= JT_TxRxDword(1, 0x0000, &dwRx, 0, JTAG_TIMEOUT);
//	Print("Config Status: %1lX...", dwRx);
	if (bFlag)	bFlag	= (dwRx & 0x01)? TRUE: FALSE;
//	Print("%s\n", STR_OKNG(bFlag));
	if (!bFlag)			return (FALSE);

	//	Move UPDATE_DR
	bFlag	= JT_TxTms(2, 0x03, 0);
	if (!bFlag)			return (FALSE);

	//	Move RUN_TEST_IDLE
	bFlag	= JT_TxTms(1, 0x00, 0);

	return (bFlag);
}


//==============================================
//	POST IDLE BYPASS
//==============================================
BOOL	PostBypass(DEVICE_INFO_T* ptDeviceInfo)
{
	BOOL	bFlag;

	bFlag	= FALSE;

	//	Bypass
	bFlag	= Bypass();
	if (!bFlag)			return (FALSE);

	//	TCK 10000
	bFlag	= JT_PluseTck(10000, 0);

	return (bFlag);
}


//==============================================
//	Transfer Bit-File
//==============================================
BOOL	ProcessFileInput(DEVICE_INFO_T* ptDeviceInfo, char* szFileName)
{
	BOOL		bFlag;
	FILE		*fp;
	BYTE		abyTx[JTAG_SIZE];
	int			seek_position=0;
	long int	file_size=0;
	long int	left_size;
	long int	sz;
	double		d;

	bFlag	= FALSE;

    clock_t startClock;
    clock_t endClock;

	startClock	= clock();

	//	Open Bit File
	if ((fp = fopen(szFileName, "rb")) == NULL) {
		Print("File Open Error [%s]\n", szFileName);
		return (FALSE);
	}

	seek_position = fseek(fp,0,SEEK_END);

	if(seek_position)
	{
		Print("File Open Error\n" );
		return (FALSE);
	}

	//	Get File Size
	file_size = ftell(fp);
	Print("Config Bit File Name: %s\n", szFileName );
	Print("Config Bit File Size: 0x%08lX(%ld)\n", file_size, file_size );

	fseek(fp,0,SEEK_SET);

	sz	= ptDeviceInfo->lFileSkip;
	if (sz)
	{
		//	Skip 44 Bytes for Cyclone device
		if (fread(&abyTx, sz, 1, fp) != 1) {
			fclose (fp);
			Print("File Read Error\n");
			return (FALSE);
		}
		file_size -= sz;
	}

	//	Config Loop
	left_size	= file_size;
	while (left_size)
	{
		Print("0x%08lX/0x%08lX (%3d%%)\r", file_size-left_size, file_size, ((file_size-left_size)*100/file_size));

		if (left_size>=JTAG_SIZE)	sz	= JTAG_SIZE;
		else						sz	= left_size;

		if (fread(&abyTx, sz, 1, fp) != 1)
		{
			fclose (fp);
			Print("File Read Error\n");
			bFlag	= FALSE;
			break;
		}

		bFlag	= JT_TxRxData((sz<<3), abyTx, NULL, 0, 0);
		if (!bFlag)									break;

		left_size	-= sz;
	}
	Print("0x%08lX/0x%08lX (100%%)\r", file_size-left_size, file_size);
	Print("\n");

	fclose (fp);

	endClock	= clock();

	//	Display Transfer Rate
	d	= (((double)(endClock - startClock))/CLOCKS_PER_SEC);
	Print( "Execution Time	= %6.3f sec,", d);
	Print( " Bit File Size = 0x%08lX bytes\n", file_size );
	sz	= (long)((file_size)/d);
	Print( " Transfer Rate = %6ld bytes/sec", sz);
	Print( "(%6.3lf Mbits/sec)\n", ((double)(sz<<3))/(1024.0*1024.0));

	return (bFlag);
}


//==============================================
int GetPinCount(DEVICE_INFO_T* ptDeviceInfo)
{
	int	nPin;
	BSCAN_CELL_T*	ptBscanCell;

	if (!ptDeviceInfo)					return (0);
	if (!(ptDeviceInfo->ptBscanCell))	return (0);

	nPin	= 0;
	do
	{
		ptBscanCell	= &(ptDeviceInfo->ptBscanCell)[nPin++];
	} while (ptBscanCell->nBitTyp);

	return (nPin);
}


//==============================================
//	MAKE BOUNDARY SCAN MPSSE TX BUFFER
//==============================================
BOOL	MakeBoundaryScan(DEVICE_INFO_T* ptDeviceInfo, BSCAN_DATA_T* ptBscanData)
{
	BYTE*	tx;
	BYTE*	rx;
	DWORD	tx_cnt;
	DWORD	rx_size;
	int		smpl;
	int		bytelen;

	//==============================================
	ptBscanData->pbyTxBuf	= NULL;
	ptBscanData->pbyRxBuf	= NULL;
	ptBscanData->dwTxSize	= 0;
	ptBscanData->dwRxSize	= 0;
	ptBscanData->nByteLen	= 0;
	ptBscanData->nSampling	= 0;
	ptBscanData->nPinCount	= 0;

	//==============================================
	if (!ptDeviceInfo)					return (FALSE);
	if (!(ptDeviceInfo->nBscanLen/8))	return (FALSE);
	if (!(ptDeviceInfo->ptBscanCell))	return (FALSE);

	//==============================================
//	tx	= JT_GetTxDataBuffer();
//	rx	= JT_GetRxDataBuffer();
	tx	= abyTxBscan;
	rx	= abyRxBscan;

	//==============================================
	//	BSCAN bits
//	bytelen	= (930/8)+1;	//	EP1C20F324	"930
//	bytelen	= (339/8)+1;	//	EP1C3T100	"339
	bytelen	= (ptDeviceInfo->nBscanLen/8)+1;

	//==============================================
	//	MAKE TX DATA
	tx_cnt	= 0;
	smpl	= 0;
	rx_size	= 0;

	while (rx_size<(DWORD)(JTAG_SIZE-0x800-(bytelen*1)-1))
	{
		//	RTI -> SIR
		tx[tx_cnt++]	= 0x4B;	//	TMS Bit LSB
		tx[tx_cnt++]	= 0x04-1;
		tx[tx_cnt++]	= 0x03;

		//	Instruction
		tx[tx_cnt++]	= 0x1B;
		tx[tx_cnt++]	= 0x08-1;
		tx[tx_cnt++]	= (BYTE)(JI_SAMPLE & 0xFF);

		//	Instruction
		tx[tx_cnt++]	= 0x1B;
		tx[tx_cnt++]	= 0x02-1-1;
		tx[tx_cnt++]	= (BYTE)((JI_SAMPLE>>8) & 0xFF);

		//	SIR -> E1R -> UIR -> SDR
		tx[tx_cnt++]	= 0x4B;	//	TMS Bit LSB
		tx[tx_cnt++]	= 0x05-1;			//	Bit Length
		tx[tx_cnt++]	= 0x07 | ((JI_SAMPLE & 0x0200)? 0x80: 0x00);	//	TMS Bit Data[LSB]

		//	Sampling Data
		tx[tx_cnt++]	= 0x28;
		tx[tx_cnt++]	= (BYTE)((bytelen-1) & 0xFF);		//	L,Byte Length
		tx[tx_cnt++]	= (BYTE)(((bytelen-1)>>8) & 0xFF);	//	H

		//	SDR -> E1D -> UDR -> RTI
		tx[tx_cnt++]	= 0x4B;	//	TMS Bit LSB
		tx[tx_cnt++]	= 0x03-1;			//	Bit Length
		tx[tx_cnt++]	= 0x03;				//	TMS Bit Data[LSB]

		smpl ++;
		rx_size	+= bytelen;
	}
	tx[tx_cnt++]	= 0x87;				//	Send Immediate

	//==============================================
	Print("%08lX %08lX %8d \n", tx_cnt, rx_size, smpl);

	//==============================================
	ptBscanData->pbyTxBuf	= tx;
	ptBscanData->pbyRxBuf	= rx;
	ptBscanData->dwTxSize	= tx_cnt;
	ptBscanData->dwRxSize	= rx_size;
	ptBscanData->nByteLen	= bytelen;
	ptBscanData->nSampling	= smpl;
	ptBscanData->nPinCount	= GetPinCount(ptDeviceInfo);

	return (TRUE);
}


//==============================================
BOOL	DoBoundaryScan(BSCAN_DATA_T* ptBscanData)
{
	BOOL	bFlag;

	//==============================================
	if (!ptBscanData)					return (FALSE);
	if (!(ptBscanData->pbyTxBuf))		return (FALSE);
	if (!(ptBscanData->pbyRxBuf))		return (FALSE);
	if (!(ptBscanData->nSampling))		return (FALSE);

	//==============================================
	bFlag	= JT_TxByte(ptBscanData->dwTxSize, ptBscanData->pbyTxBuf);
	if (!bFlag)		return (FALSE);

	bFlag	= JT_RxByte(ptBscanData->dwRxSize, ptBscanData->pbyRxBuf, 500);

	return (bFlag);
}


//==============================================
//	BOUNDARY SCAN ALTERA FPGA
//==============================================
BOOL	BoundaryScan(DEVICE_INFO_T* ptDeviceInfo, char* szFileName)
{
	BOOL	bFlag;
	double	d;
	long int	i;
	DWORD	j;
	BSCAN_DATA_T	tBscanData;
	BSCAN_DATA_T*	ptBscanData;
	FILE		*fp;

    clock_t startClock;
    clock_t endClock;

	ptBscanData	= &tBscanData;

	//==============================================
	bFlag	= MakeBoundaryScan(ptDeviceInfo, ptBscanData);
	if (!bFlag)		return (FALSE);

	//==============================================
	bFlag	= JT_PurgeBuffer();
	if (!bFlag)		return (FALSE);

	//==============================================
	if (szFileName)
	{
		//	Open Bit File
		if ((fp = fopen(szFileName, "wb")) == NULL)
		{
			Print("File Write Error [%s]\n", szFileName);
			return (FALSE);
		}
	}

	startClock	= clock();
	for (i=0; i<10; i++)
	{
		bFlag	= DoBoundaryScan(ptBscanData);
		if (!bFlag)	{	Print("BoundaryScan NG\n");	break;	}

		if (szFileName)
		{
			if (fwrite(ptBscanData->pbyRxBuf, ptBscanData->dwRxSize, 1, fp) != 1)	break;
		}

		if (0)
		{
#if	0
			//	RAW DATA
			for (j=1; j<5; j++)
			{
				Print("%3ld:", j);
				for (int xx=0; xx<ptBscanData->nByteLen; xx++)
				{
					Print("%02X", ptBscanData->pbyRxBuf[ptBscanData->nByteLen*j-xx-1]);
				}
			Print("\n");
			}
#else
			//	BSDL DATA
			for (j=0; j<10; j++)
			{
				DispBitValue(&ptBscanData->pbyRxBuf[ptBscanData->nByteLen*j], ptDeviceInfo);
				Print("\r");
			}
#endif
		}
	}
	endClock	= clock();

	if (szFileName)		fclose (fp);

	for (j=0; j<50; j++)
	{
		DispBitValue(&ptBscanData->pbyRxBuf[ptBscanData->nByteLen*j], ptDeviceInfo);
		Print("\n");
	}
	Print("\n");

	//	Display Transfer Rate
	d	= (((double)(endClock - startClock))/CLOCKS_PER_SEC);
	Print( "Execution Time	= %6.3f sec,", d);
	i	= (long)((ptBscanData->nSampling*i)/d);
	Print( " Sample Rate = %6ld sample/sec", i);
	Print( "\n");

	//==============================================
	//	BYPASS
	//==============================================
	bFlag	= Bypass();

	return (bFlag);
}


//==============================================
//	BOUNDARY SCAN ALTERA FPGA
//==============================================
BOOL	BoundaryScanW(BSCAN_DATA_T* ptBscanData)
{
	BOOL	bFlag;

	//==============================================
	bFlag	= JT_PurgeBuffer();
	if (!bFlag)		return (FALSE);

	//==============================================
	bFlag	= DoBoundaryScan(ptBscanData);
	if (!bFlag)		return (FALSE);

	//==============================================
	//	BYPASS
	//==============================================
	bFlag	= Bypass();

	return (bFlag);
}


//==============================================
BOOL	DispBitValue(BYTE* buf, DEVICE_INFO_T* ptDeviceInfo)
{
//	char	chr[8]	= {'.','O','-','I','A','B','C','D'};
	char	chr[4]	= {'.','O','-','I'};
	BSCAN_CELL_T*	ptBscanCell;

	//==============================================
	if (!ptDeviceInfo)					return (FALSE);
	if (!(ptDeviceInfo->nBscanLen/8))	return (FALSE);
	if (!(ptDeviceInfo->ptBscanCell))	return (FALSE);

	//==============================================
	ptBscanCell	= &(ptDeviceInfo->ptBscanCell)[0];

	while (ptBscanCell->nBitTyp)
	{
		GetBitValue(buf, ptBscanCell);
		Print("%c", chr[ptBscanCell->byBitVal]);
		ptBscanCell ++;
	}
	Print("\r");

	return (TRUE);
}


//==============================================
//	ALTERA ONLY
//	00,	OUT 0
//	01,	OUT 1
//	10,	INP 0
//	11,	INP 1
BOOL	GetBitValue(BYTE* buf, BSCAN_CELL_T* ptBscanCell)
{
	WORD	w;
	BYTE	v;
	int	idx;
	int	typ;

	idx	= ptBscanCell->nBitIdx;
	typ	= ptBscanCell->nBitTyp;

	w	= buf[(idx>>3)] | (buf[(idx>>3)+1]<<8);
	w	>>= (idx&0x07);

	switch (typ)
	{
	default:	return (FALSE);

	case	1:	w	&= 0x01;	w	|= 0x02;	break;
	case	3:	w	&= 0x07;					break;
	}

	switch (w)
	{
	case	0x00:
	case	0x01:	v	= 0x00;	break;

	case	0x04:
	case	0x05:	v	= 0x01;	break;

	case	0x02:
	case	0x06:	v	= 0x02;	break;

	case	0x03:
	case	0x07:	v	= 0x03;	break;

	default:		return (FALSE);
	}

	ptBscanCell->byBitVal	= v;

	return (TRUE);
}


//==============================================
#ifdef	FT_ALTERA_CONSOLE
BOOL	Altera(int argc, char* argv[]);

void	main(int argc, char* argv[])
{
	BOOL	bFlag;

    clock_t startClock;
    clock_t endClock;
	double		d;

	//==============================================
	startClock	= clock();

	fprintf(stdout, "============================================\r\n");
	fprintf(stdout, " FT2232C(MPSSE) JTAG\r\n");
	fprintf(stdout, "     CONFIGRATION & BOUNDARY SCAN PROGRAM\r\n");
	fprintf(stdout, "             for Altera FPGA series Ver 0.0\r\n");
	fprintf(stdout, " Copyright (C)2005 Y.Sakamoto\r\n");
	fprintf(stdout, " (http://hp.vector.co.jp/authors/VA014069/)\r\n");
	fprintf(stdout, "============================================\r\n");

	if (argc != 3)
	{
		fprintf(stdout, "Parameter Error\r\n");
		exit (1);
	}

	//==============================================
	//	FTDI OPEN
	//==============================================
	fprintf(stdout, "FT2232C OPEN...");
	bFlag	= JT_Open(NULL);
	fprintf(stdout, "%s\r\n", STR_OKNG(bFlag));
	if (!bFlag)	exit (2);

	//==============================================
	//	OPERATION
	//==============================================
	bFlag	= Altera(argc, argv);
	fprintf(stdout, "Operation...");
	fprintf(stdout, "%s\r\n", STR_OKNG(bFlag));

	//==============================================
	//	FTDI CLOSE
	//==============================================
	JT_Close();

	if (!bFlag)	exit (3);
	//==============================================
	endClock	= clock();

	//	Display Transfer Rate
	d	= (((double)(endClock - startClock))/CLOCKS_PER_SEC);
	fprintf(stdout, "Execution Time = %6.3f sec\r\n", d);

	exit (0);
}


//==============================================
//	ALTERA FPGA
//==============================================
BOOL	Altera(int argc, char* argv[])
{
	BOOL	bFlag;
	DWORD	dwIdCode;
	DEVICE_INFO_T*	ptDeviceInfo;

	//==============================================
	//	FTDI INIT
	//==============================================
	bFlag	= JT_Initialize();
	Print("FT2232C INIT...");
	Print("%s\n", STR_OKNG(bFlag));
	if (!bFlag)		return (FALSE);

	//==============================================
	//	TARGET POWER
	//==============================================
//	bFlag	= JT_CheckPower();
//	Print("TARGET POWER...");
//	Print("%s\n", STR_OKNG(bFlag));
//	if (!bFlag)		return (FALSE);

	//==============================================
	//	RUN TEST IDLE
	//==============================================
	bFlag	= RunTestIdle();
	Print("DEVICE INIT...");
	Print("%s\n", STR_OKNG(bFlag));
	if (!bFlag)		return (FALSE);

	//==============================================
	//	VERIFY JTAG CHAIN
	//==============================================
	bFlag	= VerifyChain();
	Print("VERIFY JTAG CHAIN...");
	Print("%s\n", STR_OKNG(bFlag));
	if (!bFlag)		return (FALSE);

	//==============================================
	//	IDCODE
	//==============================================
	Print("DEVICE IDCODE...");
	bFlag	= GetIdCode(&dwIdCode);
	Print("%s\n", STR_OKNG(bFlag));
	if (!bFlag)		return (FALSE);

	ptDeviceInfo	= GetDeviceInfo(dwIdCode);
	Print("IDCODE=%08lX:", dwIdCode);
	if (ptDeviceInfo)
	{
		Print("OK, Altera %s\n", ptDeviceInfo->szDeviceName);
	}
	else
	{
		Print("NG, UnKnown\n");
		return (FALSE);
	}

	//==============================================
	//	OPERATION
	//==============================================
	Print("Operation...");
	if (argc != 3)
	{
		Print("Parameter Error\n");
	}
	else
	{
		switch (argv[1][0])
		{
		case	'B':
		case	'b':
			//==============================================
			//	BOUNDARY SCAN ALTERA FPGA
			//==============================================
			Print("BoundaryScan\n");
//			bFlag	= BoundaryScan(ptDeviceInfo, argv[2]);
			bFlag	= BoundaryScan(ptDeviceInfo, NULL);
			break;

		case	'C':
		case	'c':
			//==============================================
			//	CONFIGURE ALTERA FPGA
			//==============================================
			Print("Configure\n");
			bFlag	= Configure(ptDeviceInfo, argv[2]);

			Print("Check Status...");
			Print("%s\n", STR_OKNG(bFlag));

			break;

		default:
			Print("Command Error\n");
			bFlag	= FALSE;
			break;
		}
	}

	return (bFlag);
}
#endif


//==============================================
void	Print(char *form, ...)
{
#ifdef	FT_ALTERA_CONSOLE
	va_list	argPtr;
	char	str[80+1];

	va_start(argPtr, form);
	_vsnprintf(str, 80, form, argPtr);
	printf(str);
	va_end(argPtr);
#endif

	return;
}


