//==============================================
//	FT_JTAG FTDI FT2232C MPSSE JTAG module		
//		2005/03/01		Ver 0.0					
//												
//	Compiled Visual C++ Ver5.0 with D2XX DLL ver.1.10
//												
//	Windows98SE    with D2XX Driver ver.1.10	
//	Windows2000Pro with D2XX Driver ver.1.03	
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================
/*
	{vO̒쌠yт̑؂͍̌{@NL܂B
	āA쌠NQsׂ͖@ɂĈ؋֎~Ă܂B
	{vȎS܂͈ꕔcړIŎgpꍇɂ͕K{@N̎Oʓӂv܂B
	_ɑΉ܂̂łCyɖ₢킹B
	ӌ䊴zCyɂ񂹂B

	{@Ñz[y[W
	http://hp.vector.co.jp/authors/VA014069
*/
//==============================================

#include <stdio.h>
#include <windows.h>

#include "FT_Mpsse.h"
#include "FT_Jtag.h"


//==============================================
#define	JTAG_DEBUG	0


//==============================================
BYTE	abyTxBuf[MPSSE_BUFFER_MAX];	//	Transfer
BYTE	abyRxBuf[MPSSE_BUFFER_MAX];	//	Receive

WORD	wJtPortData;				//	I/O Port Data


//==============================================
BOOL	JT_Open(void* pvAdapter)
{
	//	Open
	return (FTDI_OpenDevice());
}


//==============================================
BOOL	JT_Close(void)
{
	//	Close
	return (FTDI_CloseDevice());
}


//==============================================
BOOL	JT_Initialize(void)
{
	BOOL	bFlag;

	//	Initialize
	bFlag	= FTDI_Initialize();
	if (!bFlag)				return (FALSE);

	//	CLK DIVISOR
	bFlag	= FTDI_SetClkDivisor(1-1);		//	6MHz
//	bFlag	= FTDI_SetClkDivisor(6-1);		//	1MHz
//	bFlag	= FTDI_SetClkDivisor(60-1);		//	100kHz
	if (!bFlag)				return (FALSE);

	//	Initialize Port
	bFlag	= JT_OutputPort(JTAG_PORT_DAT, 0xFFFF);
	if (!bFlag)				return (FALSE);

	return (bFlag);
}


//==============================================
BOOL	JT_PurgeBuffer(void)
{
	//	Purge
	return (FTDI_PurgeBuffer());
}


//==============================================
BOOL	JT_PluseTck(DWORD dwTckCount, BOOL bTdiPin)
{
	BOOL	bFlag;
	DWORD	dwBlockLoop;
	DWORD	dwByteSize;
	DWORD	dwBitSize;
	BYTE	dmy;
	BYTE	abyTxTmp[256];
	int	i;

	//	Check Bit Length
	if ( (dwTckCount < 1) || (dwTckCount > (JTAG_BUFFER_MAX<<3)) )	return (FALSE);

	dmy	= (bTdiPin)? 0xFF: 0x00;
	for (i = 0; i < 256; i ++)
		abyTxTmp[i]	= dmy;

	//	Calc Byte/Bit Size
	dwBlockLoop	= dwTckCount >> (8+3);
	dwByteSize	= (dwTckCount >> 3) & 0xFF;
	dwBitSize	= (dwTckCount & 0x07);

	//	256 Byte(2048 Bit)
	while (dwBlockLoop--)
	{
		bFlag	= JT_TxRxByte(256, abyTxTmp, NULL, 0);
		if (!bFlag)				return (FALSE);
	}

	//	1-255 Byte(8-2040 Bit)
	if (dwByteSize) {
		bFlag	= JT_TxRxByte(dwByteSize, abyTxTmp, NULL, 0);
		if (!bFlag)				return (FALSE);
	}

	//	1-7 Bit
	if (dwBitSize) {
		bFlag	= JT_TxRxBit(dwBitSize, abyTxTmp, NULL, 0, 0);
		if (!bFlag)				return (FALSE);
	}

	return (TRUE);
}


//==============================================
BOOL	JT_TxTms(BYTE dwBitLength, BYTE byTmsData, BOOL bTdiPin)
{
	BOOL	bFlag;
	BYTE	ft_command;
	DWORD	tx_cnt;

	//	Check Bit Length
	if ( (dwBitLength < 1) || (dwBitLength > 6) )	return (FALSE);

	//	MPSSE COMMAND[TMS Bit LSB]
	//	0x4B	Tx
	//	(0x6B)	TxRx
	ft_command	= 0x4B;	//	TMS Bit LSB

	tx_cnt	= 0;
	abyTxBuf[tx_cnt++]	= ft_command;
	abyTxBuf[tx_cnt++]	= dwBitLength - 1;		//	Bit Length
	if (bTdiPin)		byTmsData	|= 0x80;	//	TDI = '1'
	else				byTmsData	&= ~0x80;	//	TDI = '0'
	abyTxBuf[tx_cnt++]	= byTmsData;			//	TMS Bit Data[LSB]

	//	Transfer
	bFlag	= FTDI_TransferBuffer(abyTxBuf, tx_cnt);

	return (bFlag);
}


//==============================================
BOOL	JT_TxRxData(DWORD dwBitLength, BYTE* pbyTxData, BYTE* pbyRxData, BOOL bLastTms, DWORD dwTimeOutMs)
{
	BOOL	bFlag;
	DWORD	dwByteSize;
	DWORD	dwBitSize;
	BYTE* pbyTxBit;
	BYTE* pbyRxBit;

	//	Check Bit Length
	if ( (dwBitLength < 1) || (dwBitLength > (JTAG_BUFFER_MAX<<3)) )	return (FALSE);

	//	Check Data Address
	if (!pbyTxData && !pbyRxData)	return (FALSE);

	//	Calc Byte/Bit Size
	dwByteSize	= dwBitLength >> 3;
	dwBitSize	= dwBitLength & 0x07;

	//	TMS ?
	if ( (bLastTms) && (dwBitSize == 0) )
	{
		dwByteSize--;
		dwBitSize	= 8;
	}

	//	Byte Data
	if (dwByteSize) {
		bFlag	= JT_TxRxByte(dwByteSize, pbyTxData, pbyRxData, dwTimeOutMs);
		if (!bFlag)				return (FALSE);
	}

	//	Bit Data
	if (dwBitSize) {
		//	Last Position Tx
		if (pbyTxData)	pbyTxBit	= &pbyTxData[dwByteSize];
		else			pbyTxBit	= NULL;

		//	Last Position Rx
		if (pbyRxData)	pbyRxBit	= &pbyRxData[dwByteSize];
		else			pbyRxBit	= NULL;

		bFlag	= JT_TxRxBit(dwBitSize, pbyTxBit, pbyRxBit, bLastTms, dwTimeOutMs);
		if (!bFlag)				return (FALSE);
	}

	return (TRUE);
}


//==============================================
BOOL	JT_TxRxByte(DWORD dwByteSize, BYTE* pbyTxData, BYTE* pbyRxData, DWORD dwTimeOutMs)
{
	BOOL	bFlag;
	BYTE	ft_command;
	DWORD	tx_cnt;

	//	Check Byte Size
	if ( (dwByteSize < 1) || (dwByteSize > JTAG_BUFFER_MAX) )	return (FALSE);

	//	Check Data Address
	if (!pbyTxData && !pbyRxData)	return (FALSE);

	//	MPSSE COMMAND[TDI Byte LSB]
	//	0x19	Tx
	//	0x28	  Rx
	//	0x39	TxRx
	ft_command	= 0x08;	//	TDI Byte LSB
	if (pbyTxData)	ft_command	|= 0x11;	//	Out
	if (pbyRxData)	ft_command	|= 0x20;	//	Inp

	tx_cnt	= 0;
	abyTxBuf[tx_cnt++]	= ft_command;
	abyTxBuf[tx_cnt++]	= (BYTE)((dwByteSize-1) & 0xFF);	//	L,Byte Length
	abyTxBuf[tx_cnt++]	= (BYTE)((dwByteSize-1)>>8);		//	H

	if (pbyTxData)
	{
		//	Byte Data[LSB]
		memcpy(&abyTxBuf[tx_cnt], &pbyTxData[0], dwByteSize);
		tx_cnt	+= dwByteSize;
	}

	if (pbyRxData)	abyTxBuf[tx_cnt++]	= 0x87;				//	Send Immediate

	//	Transfer
	bFlag	= FTDI_TransferBuffer(abyTxBuf, tx_cnt);
	if (!bFlag)				return (FALSE);
	if (!pbyRxData)			return (TRUE);

	//	Receive
	bFlag	= FTDI_WaitReceiveBuffer(abyRxBuf, dwByteSize, dwTimeOutMs);
	if (!bFlag)				return (FALSE);

	memcpy(&pbyRxData[0], &abyRxBuf[0], dwByteSize);

#if	JTAG_DEBUG
	printf("R:BYTE [[%02X,%02X]]->%02X\n", abyRxBuf[1], abyRxBuf[0], pbyRxData[0]);
#endif

	return (TRUE);
}


//==============================================
BOOL	JT_TxRxBit(DWORD dwBitSize, BYTE* pbyTxData, BYTE* pbyRxData, BOOL bLastTms, DWORD dwTimeOutMs)
{
	BOOL	bFlag;
	BYTE	ft_command;
	DWORD	tx_cnt;
	BYTE	byBitSizePre;
	DWORD	dwReceiveSize;
	BYTE	byTmsData;

	//	Check Bit Size
	if ( (dwBitSize < 1) || (dwBitSize > 8) )	return (FALSE);

	//	Check Data Address
	if (!pbyTxData && !pbyRxData)	return (FALSE);

	dwReceiveSize	= 0;

	byBitSizePre	= (BYTE)(dwBitSize);
	if (bLastTms)	byBitSizePre--;

	tx_cnt	= 0;

	//	Byte Bit ?
	if (byBitSizePre)
	{
		//	MPSSE COMMAND[TDI Bit LSB]
		//	0x1B	Tx
		//	0x2A	  Rx
		//	0x3B	TxRx
		ft_command	= 0x0A;	//	TDI Bit LSB
		if (pbyTxData)	ft_command	|= 0x11;	//	Out
		if (pbyRxData)	ft_command	|= 0x20;	//	Inp
		abyTxBuf[tx_cnt++]	= ft_command;
		abyTxBuf[tx_cnt++]	= byBitSizePre-1;	//	Bit Length
		if (pbyTxData)	abyTxBuf[tx_cnt++]	= pbyTxData[0];		//	TDI Bit Data[LSB]
		if (pbyRxData)	dwReceiveSize++;
	}

	//	TMS ?
	if (bLastTms)
	{
		//	MPSSE COMMAND[TMS Bit LSB]
		//	0x4B	Tx
		//	0x6B	TxRx
		ft_command	= 0x4B;	//	TMS Bit LSB
		if (pbyRxData)	ft_command	|= 0x20;	//	Inp
		abyTxBuf[tx_cnt++]	= ft_command;
		abyTxBuf[tx_cnt++]	= 0x00;				//	Bit Length

		byTmsData	= 0x01;
		if (pbyTxData)
		{
			if ((pbyTxData[0] >> byBitSizePre) & 0x01)
				byTmsData	|= 0x80;			//	TDI='1'
		}
		abyTxBuf[tx_cnt++]	= byTmsData;		//	TMS Bit Data[LSB]
		if (pbyRxData)	dwReceiveSize++;
	}

	if (pbyRxData)	abyTxBuf[tx_cnt++]	= 0x87;	//	Send Immediate

	//	Transfer
	bFlag	= FTDI_TransferBuffer(abyTxBuf, tx_cnt);
	if (!bFlag)				return (FALSE);
	if (!pbyRxData)			return (TRUE);

	//	Receive
	bFlag	= FTDI_WaitReceiveBuffer(abyRxBuf, dwReceiveSize, dwTimeOutMs);
	if (!bFlag)				return (FALSE);

	//	Shift Bit
	if (byBitSizePre)	abyRxBuf[0]	>>= (8-byBitSizePre);
	else				abyRxBuf[0]	>>= 7;		//	Last TMS's TDO
	pbyRxData[0]	= abyRxBuf[0];

	if ( (byBitSizePre) && (bLastTms) )
	{
		abyRxBuf[1]	>>= 7;		//	Last TMS's TDO
		pbyRxData[0]	|= ((abyRxBuf[1] & 0x01) << byBitSizePre);
	}

#if	JTAG_DEBUG
	printf("R:BIT  [[%02X,%02X]]->%02X\n", abyRxBuf[1], abyRxBuf[0], pbyRxData[0]);
#endif

	return (TRUE);
}


//==============================================
BOOL	JT_TxRxDword(DWORD dwBitLength, DWORD dwTxData, DWORD* pdwRxData, BOOL bLastTms, DWORD dwTimeOutMs)
{
	BOOL	bFlag;
	BYTE	abyTxTmp[4];
	BYTE	abyRxTmp[4];

	//	Check Bit Length
	if ( (dwBitLength < 1) || (dwBitLength > 32) )	return (FALSE);

#if	JTAG_DEBUG
	printf("JTAG DWORD: S:%08lX/%d\n", dwTxData, dwBitLength);
#endif

	//	Send Data
	dwTxData	&= (0xFFFFFFFF >> (32-dwBitLength));
	abyTxTmp[0]	= (BYTE)(dwTxData & 0xFF);
	abyTxTmp[1]	= (BYTE)((dwTxData>> 8) & 0xFF);
	abyTxTmp[2]	= (BYTE)((dwTxData>>16) & 0xFF);
	abyTxTmp[3]	= (BYTE)((dwTxData>>24) & 0xFF);

	if (pdwRxData)
	{
		bFlag	= JT_TxRxData(dwBitLength, abyTxTmp, abyRxTmp, bLastTms, dwTimeOutMs);
		//	Recv Data
		*pdwRxData	= abyRxTmp[0];
		*pdwRxData	|= (abyRxTmp[1]<<8);
		*pdwRxData	|= (abyRxTmp[2]<<16);
		*pdwRxData	|= (abyRxTmp[3]<<24);

		*pdwRxData	&= (0xFFFFFFFF >> (32-dwBitLength));
#if	JTAG_DEBUG
		printf("JTAG DWORD: R:%08lX/%d\n", *pdwRxData, dwBitLength);
#endif
	}
	else
	{
		bFlag	= JT_TxRxData(dwBitLength, abyTxTmp, NULL, bLastTms, dwTimeOutMs);
	}

	return (bFlag);
}


//==============================================
BOOL	JT_TxByte(DWORD dwByteSize, BYTE* pbyTxData)
{
	BOOL	bFlag;

	//	Check Byte Size
	if ( (dwByteSize < 1) || (dwByteSize > JTAG_BUFFER_MAX) )	return (FALSE);

	//	Check Data Address
	if (!pbyTxData)			return (FALSE);

	//	Transfer
	bFlag	= FTDI_TransferBuffer(pbyTxData, dwByteSize);

	return (bFlag);
}


//==============================================
BOOL	JT_RxByte(DWORD dwByteSize, BYTE* pbyRxData, DWORD dwTimeOutMs)
{
	BOOL	bFlag;

	//	Check Byte Size
	if ( (dwByteSize < 1) || (dwByteSize > JTAG_BUFFER_MAX) )	return (FALSE);

	//	Check Data Address
	if (!pbyRxData)			return (FALSE);

	//	Receive
	bFlag	= FTDI_WaitReceiveBuffer(pbyRxData, dwByteSize, dwTimeOutMs);

	return (bFlag);
}


//==============================================
BOOL	JT_OutputPort(WORD wPortData, WORD wPortMask)
{
	BOOL	bFlag;

	wPortData	&= wPortMask;
	wJtPortData	&= ~wPortMask;
	wJtPortData	|= wPortData;

	//	Set I/O Low Bits
	bFlag	= FTDI_SetPort(0, (wJtPortData & 0xFF), (JTAG_PORT_DIR & 0xFF));
	if (!bFlag)								return (FALSE);

	//	Set I/O High Bits
	bFlag	= FTDI_SetPort(1, ((wJtPortData>>8) & 0xFF), ((JTAG_PORT_DIR>>8) & 0xFF));

	return (bFlag);
}


//==============================================
BOOL	JT_InputPort(WORD* pwPortData)
{
	BOOL	bFlag;
	BYTE	rx;

	if (pwPortData)		*(pwPortData)	= 0;

	//	Get I/O Low Bits
	bFlag	= FTDI_GetPort(0, &rx);
	if (!bFlag)								return (FALSE);
	if (pwPortData)		*(pwPortData)	= rx;

	//	Get I/O High Bits
	bFlag	= FTDI_GetPort(1, &rx);
	if (!bFlag)								return (FALSE);
	if (pwPortData)		*(pwPortData)	|= (rx<<8);

	return (TRUE);
}


//==============================================
BOOL	JT_SetPin(WORD wPortPin, WORD wPortValue)
{
	WORD	wPortData;

	wPortData	= wPortValue? wPortPin: 0;
	return (JT_OutputPort(wPortData, wPortPin));
}


//==============================================
BOOL	JT_GetPin(WORD wPortPin, WORD* pwPortValue)
{
	BOOL	bFlag;
	WORD	wPortData;

	if (pwPortValue)	*(pwPortValue)	= 0;

	bFlag	= JT_InputPort(&wPortData);
	if (!bFlag)								return (FALSE);
	if (pwPortValue)	*(pwPortValue)	= wPortData & wPortPin;

	return (TRUE);
}


//==============================================
BOOL	JT_CheckPower(void)
{
	BOOL	bFlag;
	WORD	wPortValue;

	bFlag	= JT_GetPin(JTAG_PORT_I_POW, &wPortValue);
	if (!bFlag)								return (FALSE);
	//	0 != OK
	if (!wPortValue)						return (FALSE);

	return (TRUE);
}


//==============================================
BYTE*	JT_GetTxDataBuffer(void)
{
	return (abyTxBuf);
}


//==============================================
BYTE*	JT_GetRxDataBuffer(void)
{
	return (abyRxBuf);
}


