//==============================================
//	FT_JTAG FTDI FT2232C MPSSE JTAG module		
//		2005/03/01		Ver 0.0					
//												
//	Compiled VisualC++ Ver5.0 with D2XX DLL ver.1.10
//												
//	Windows98SE    with D2XX Driver ver.1.10	
//	Windows2000Pro with D2XX Driver ver.1.03	
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================


//==============================================
//	DEFINE
//==============================================
#define	JTAG_TIMEOUT		(50)				/*	50ms	*/

#define	JTAG_BUFFER_MAX		(0x10000)			/*	DATA(0x10000)	*/
#define	MPSSE_BUFFER_MAX	(JTAG_BUFFER_MAX+4)	/*	DATA(0x10000) + COMMAND(0x03) + SEND IMMEDIATE(0x01)	*/


//	Port Data [x,x,x,x,x,POW,x,x,TMS,TDO,TDI,TCK]=[xxxx_x0xx_1x00]
#define	JTAG_PORT_DAT	(0x0008)

//	Direction [x,x,x,x,x,POW,x,x,TMS,TDO,TDI,TCK]=[xxxx_xIxx_OIOO]
#define	JTAG_PORT_DIR	(0x000B)

//	JTAG I/O(ALTERA ByteBlaster2)
#define	JTAG_PORT_O_TCK	(1<< 0)		/*	AD0	O Low	*/
#define	JTAG_PORT_O_TDI	(1<< 1)		/*	AD1	O */
#define	JTAG_PORT_I_TDO	(1<< 2)		/*	AD2	I */
#define	JTAG_PORT_O_TMS	(1<< 3)		/*	AD3	O */
#define	JTAG_PORT_x_AD4	(1<< 4)		/*	AD4	x */
#define	JTAG_PORT_x_AD5	(1<< 5)		/*	AD5	x */
#define	JTAG_PORT_I_POW	(1<< 6)		/*	AD6	I */
#define	JTAG_PORT_x_AD7	(1<< 7)		/*	AD7	x */

#define	JTAG_PORT_x_AC0	(1<< 8)		/*	AC0	x High	*/
#define	JTAG_PORT_x_AC1	(1<< 9)		/*	AC1	x */
#define	JTAG_PORT_x_AC2	(1<<10)		/*	AC2	x */
#define	JTAG_PORT_x_AC3	(1<<11)		/*	AC3	x */


//==============================================
BOOL	JT_Open(void* pvAdapter);
BOOL	JT_Close(void);
BOOL	JT_Initialize(void);
BOOL	JT_PurgeBuffer(void);
BOOL	JT_PluseTck(DWORD dwTckCount, BOOL bTdiPin);
BOOL	JT_TxTms(BYTE dwBitLength, BYTE byTmsData, BOOL bTdiPin);
BOOL	JT_TxRxData(DWORD dwBitLength, BYTE* pbyTxData, BYTE* pbyRxData, BOOL bLastTms, DWORD dwTimeOutMs);
BOOL	JT_TxRxByte(DWORD dwByteSize, BYTE* pbyTxData, BYTE* pbyRxData, DWORD dwTimeOutMs);
BOOL	JT_TxRxBit(DWORD dwBitSize, BYTE* pbyTxData, BYTE* pbyRxData, BOOL bLastTms, DWORD dwTimeOutMs);
BOOL	JT_TxRxDword(DWORD dwBitLength, DWORD dwTxData, DWORD* pdwRxData, BOOL bLastTms, DWORD dwTimeOutMs);
BOOL	JT_TxByte(DWORD dwByteSize, BYTE* pbyTxData);
BOOL	JT_RxByte(DWORD dwByteSize, BYTE* pbyRxData, DWORD dwTimeOutMs);
BOOL	JT_OutputPort(WORD wPortData, WORD wPortMask);
BOOL	JT_InputPort(WORD* pwPortData);
BOOL	JT_SetPin(WORD wPortPin, WORD wPortValue);
BOOL	JT_GetPin(WORD wPortPin, WORD* pwPortValue);
BOOL	JT_CheckPower(void);
BYTE*	JT_GetTxDataBuffer(void);
BYTE*	JT_GetRxDataBuffer(void);


