//==============================================
//	FT_MPSSE FTDI FT2232C MPSSE JTAG module		
//		2005/03/01		Ver 0.0					
//												
//	Compiled Visual C++ Ver5.0 with D2XX DLL ver.1.10
//												
//	Windows98SE    with D2XX Driver ver.1.10	
//	Windows2000Pro with D2XX Driver ver.1.03	
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================
/*
	{vO̒쌠yт̑؂͍̌{@NL܂B
	āA쌠NQsׂ͖@ɂĈ؋֎~Ă܂B
	{vȎS܂͈ꕔcړIŎgpꍇɂ͕K{@N̎Oʓӂv܂B
	_ɑΉ܂̂łCyɖ₢킹B
	ӌ䊴zCyɂ񂹂B

	{@Ñz[y[W
	http://hp.vector.co.jp/authors/VA014069
*/
//==============================================

#include <windows.h>

#include "Ftd2xx.h"
#include "FT_Mpsse.h"


//==============================================
//==============================================
FT_HANDLE	ftHandle	= NULL;


//==============================================
//	FTDI Subroutine
//==============================================
BOOL	FTDI_OpenDevice(void)
{
	FT_STATUS	ftStatus;
	DWORD		dwDeviceCount;

	ftHandle	= NULL;

	//	List FTDI device
	ftStatus	= FT_ListDevices(&dwDeviceCount, NULL, FT_LIST_NUMBER_ONLY);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);
	if (dwDeviceCount < 1)				return (FALSE);

	//	Open
	ftStatus	= FT_Open(0, &ftHandle);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_CloseDevice(void)
{
	FT_STATUS	ftStatus;

	//	Close FTDI device
	ftStatus	= FT_Close(ftHandle);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_Initialize(void)
{
	FT_STATUS	ftStatus;
	BYTE		abyBuf[1];

	//	Initialize FT2232C

//	//	Reset
//	ftStatus	= FT_ResetDevice(ftHandle);
//	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Purge Buffer
	ftStatus	= FT_Purge(ftHandle, FT_PURGE_RX | FT_PURGE_TX);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Set Latency Timer 16ms
	ftStatus	= FT_SetLatencyTimer(ftHandle, 16);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Reset controller
	ftStatus	= FT_SetBitMode(ftHandle, 0x00, 0x00);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Enable JTAG(MPSSE) controller
	ftStatus	= FT_SetBitMode(ftHandle, 0x00, 0x02);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Purge Buffer
	ftStatus	= FT_Purge(ftHandle, FT_PURGE_RX | FT_PURGE_TX);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Wait for all the USB stuff to complete
	Sleep(20);

//	//	500ms,500ms
//	ftStatus	= FT_SetTimeouts(ftHandle, 500, 500);
//	if (!FT_SUCCESS(ftStatus))			return (FALSE);

//	//	Set USB Parameters
//	ftStatus	= FT_SetUSBParameters(ftHandle, 4096, 0);
//	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	//	Loop Back Off
	abyBuf[0]	= 0x85;	//	Turn Off Loop Back

	//	Transfer
	return (FTDI_TransferBuffer(abyBuf, 1));
}


//==============================================
BOOL	FTDI_PurgeBuffer(void)
{
	FT_STATUS	ftStatus;

	//	Purge Buffer
	ftStatus	= FT_Purge(ftHandle, FT_PURGE_RX | FT_PURGE_TX);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_TransferBuffer(BYTE* pbyTxBuffer, DWORD dwTxSize)
{
	FT_STATUS	ftStatus;
	DWORD	dwBytesWritten;

	if (!pbyTxBuffer)					return (FALSE);
	if (!dwTxSize)						return (FALSE);

	//	Write
	ftStatus	= FT_Write(ftHandle, pbyTxBuffer, dwTxSize, &dwBytesWritten);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);
	if (dwBytesWritten != dwTxSize)		return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_WaitQueue(DWORD dwRxSize, DWORD dwTimeOutMs)
{
	FT_STATUS	ftStatus;
	DWORD		dwRxBytes;

	do
	{
		//	Queue
		ftStatus	= FT_GetQueueStatus(ftHandle, &dwRxBytes);
		if (!FT_SUCCESS(ftStatus))		return (FALSE);
		if (dwRxBytes >= dwRxSize)		return (TRUE);

		Sleep(1);
	} while (dwTimeOutMs--);

	return (FALSE);
}


//==============================================
BOOL	FTDI_ReceiveBuffer(BYTE* pbyRxBuffer, DWORD dwRxSize)
{
	FT_STATUS	ftStatus;
	DWORD		dwBytesReturned;

	if (!pbyRxBuffer)					return (FALSE);
	if (!dwRxSize)						return (FALSE);

	//	Read
	ftStatus	= FT_Read(ftHandle, pbyRxBuffer, dwRxSize, &dwBytesReturned);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);
	if (dwBytesReturned != dwRxSize)	return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_WaitReceiveBuffer(BYTE* pbyRxBuffer, DWORD dwRxSize, DWORD dwTimeOutMs)
{
	if (!pbyRxBuffer)					return (FALSE);
	if (!dwRxSize)						return (FALSE);

	//	Wait & Read
	if (FTDI_WaitQueue(dwRxSize, dwTimeOutMs) != TRUE)	return (FALSE);
	return (FTDI_ReceiveBuffer(pbyRxBuffer, dwRxSize));
}


//==============================================
BOOL	FTDI_SetClkDivisor(WORD wDivisor)
{
	BYTE	abyBuf[3];

	//	Set Clk Divisor
	abyBuf[0]	= 0x86;							// Set Clk Divisor
	abyBuf[1]	= (BYTE)(wDivisor & 0xFF);		// L,(0x0000=6MHz)
	abyBuf[2]	= (BYTE)((wDivisor>>8) & 0xFF);	// H

	//	Transfer
	return (FTDI_TransferBuffer(abyBuf, 3));
}


//==============================================
BOOL	FTDI_SetLatencyTimer(UCHAR ucTimer)
{
	FT_STATUS	ftStatus;

	//	Set Latency Timer 16ms
	ftStatus	= FT_SetLatencyTimer(ftHandle, ucTimer);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_SetTimeouts(ULONG ulReadTimeout, ULONG ulWriteTimeout)
{
	FT_STATUS	ftStatus;

	//	Set Timeouts
	ftStatus	= FT_SetTimeouts(ftHandle, ulReadTimeout, ulWriteTimeout);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_SetUSBParameters(ULONG ulInTransferSize, ULONG ulOutTransferSize)
{
	FT_STATUS	ftStatus;

	//	Set USB Parameters
	ftStatus	= FT_SetUSBParameters(ftHandle, ulInTransferSize, ulOutTransferSize);
	if (!FT_SUCCESS(ftStatus))			return (FALSE);

	return (TRUE);
}


//==============================================
BOOL	FTDI_SetPortEx(BYTE byPortType, BYTE byPortData, BYTE byPortDir)
{
	BYTE	abyBuf[3];

	//	Set I/O Port
	if (byPortType == 0)	abyBuf[0]	= 0x80;	//	Set I/O Low Bits
	else					abyBuf[0]	= 0x82;	//	Set I/O High Bits
	abyBuf[1]	= byPortData;	//	Port Data
	abyBuf[2]	= byPortDir;	//	Direction

	//	Transfer
	return (FTDI_TransferBuffer(abyBuf, 3));
}


//==============================================
BOOL	FTDI_SetPort(BYTE byPortType, BYTE byPortData, BYTE byPortDir)
{

	//	Set I/O Port
	if (byPortType == 0)
	{
		//	Direction Guard [x,x,x,x,TMS,TDO,TDI,TCK]	=[xxxx_OIOO]
		byPortDir	|= 0x0B;
		byPortDir	&= ~0x04;
	}
	else
	{
		//	Direction Guard
		byPortDir	|= 0x00;
		byPortDir	&= ~0x00;
	}

	//	Transfer
	return (FTDI_SetPortEx(byPortType, byPortData, byPortDir));
}


//==============================================
BOOL	FTDI_GetPort(BYTE byPortType, BYTE* pbyPortData)
{
	BOOL	bFlag;
	BYTE	abyBuf[2];

	if (pbyPortData)		*(pbyPortData)	= 0;

	//	Get I/O Port
	if (byPortType == 0)	abyBuf[0]	= 0x81;	//	Get I/O Low Bits
	else					abyBuf[0]	= 0x83;	//	Get I/O High Bits
	abyBuf[1]	= 0x87;							//	Send Immediate

	//	Transfer
	bFlag	= FTDI_TransferBuffer(abyBuf, 2);
	if (!bFlag)				return (FALSE);

	//	Receive
	bFlag	= FTDI_WaitReceiveBuffer(abyBuf, 1, 10);
	if (!bFlag)				return (FALSE);

	if (pbyPortData)		*(pbyPortData)	= abyBuf[0];

	return (TRUE);
}


