//==============================================
//	FPGA DEFINE									
//		2005/03/01		Ver 0.0					
//												
//		Programed By	Y.Sakamoto				
//		Copyright (C)2005 Y.Sakamoto			
//==============================================


//==============================================
//	Boundary Scan Data Struct
typedef struct {
	BYTE*	pbyTxBuf;
	BYTE*	pbyRxBuf;
	DWORD	dwTxSize;
	DWORD	dwRxSize;
	int		nByteLen;
	int		nSampling;
	int		nPinCount;
} BSCAN_DATA_T;


//==============================================
//	Boundary Scan Device Information Struct
typedef struct {
	char*	szPinName;
	int		nBitIdx;
	int		nBitTyp;
	BYTE	byBitVal;
} BSCAN_CELL_T;


//==============================================
//	FPGA Device Information Struct
typedef struct {
	DWORD	dwIdCode;
	int		nMaxClk;
	int		nDoneClk;
	int		nInstLen;
	long int	lFileSkip;
	char*	szDeviceName;
	int		nBscanLen;
	BSCAN_CELL_T*	ptBscanCell;
} DEVICE_INFO_T;


